package ru.landrafhomyak.utility.reference_counter

import java.util.concurrent.atomic.AtomicLong

internal actual /*value*/ class _AtomicLong {
	private val _native: AtomicLong

	actual constructor(initial: Long) {
		this._native = AtomicLong(initial)
	}

	actual fun get() = this._native.get()

	actual inline fun update(operator: (Long) -> Long) {
		while (true) {
			val cur = this._native.get()
			val upd = operator(cur)
			if (this._native.compareAndSet(cur, upd)) return
		}
	}

	actual inline fun getAndUpdate(operator: (Long) -> Long): Long {
		while (true) {
			val cur = this._native.get()
			val upd = operator(cur)
			if (this._native.compareAndSet(cur, upd)) return cur
		}
	}

	actual fun compareAndSet(expected: Long, newValue: Long): Boolean =
		this._native.compareAndSet(expected, newValue)

	actual fun compareAndExchange(expected: Long, newValue: Long): Long {
		if (_Linkage._isNativeCompareAndExchangeExists) {
			return this._native.compareAndExchange(expected, newValue)
		} else {
			val a = this._native
			return _Misc._compareAndExchange(
				get = a::get,
				cas = a::compareAndSet,
				expected = expected, newValue = newValue
			)
		}
	}

	private object _Linkage {
		@JvmField
		val _isNativeCompareAndExchangeExists = run {
			val a = AtomicLong()
			try {
				a.compareAndExchange(0, 0)
				return@run true
			} catch (_: NoSuchMethodError) {
				return@run false
			}
		}
	}
}